DIR_RIGHT = 0
DIR_LEFT  = 180
DIR_UP    = 90
DIR_DOWN  = 270

Cursor = {
  x = 0,
  y = 0,
  w = 0,
  h = 0,
  direction = DIR_RIGHT
}
Cursor.__index = Cursor

function Cursor.new(x, y, w, h, direction)
  local cursor = {}
  setmetatable(cursor, Cursor)
  cursor.x = x
  cursor.y = y
  cursor.w = w
  cursor.h = h
  cursor.direction = direction
  return cursor
end

function Cursor:setPosition(x,y)
  self.x = x
  self.y = y
end

function Cursor:setDirection(direction)
  self.direction = direction
end

function Cursor:setRandomDirection()
  local directions = { DIR_RIGHT, DIR_LEFT, DIR_UP, DIR_DOWN }
  self.direction = directions[math.random(#directions)]
end

function Cursor:moveLeft()
  if (self.x > 0) then
    self.x = self.x - 1
  else 
    self.x = self.w - 1
  end
end

function Cursor:moveRight()
  if (self.x < self.w - 1) then
    self.x = self.x + 1
  else 
    self.x = 0
  end
end

function Cursor:moveUp()
  if (self.y > 0) then
    self.y = self.y - 1
  else 
    self.y = self.h - 1
  end
end

function Cursor:moveDown()
  if (self.y < self.h - 1) then
    self.y = self.y + 1
  else 
    self.y = 0
  end
end

function Cursor:move()
  if (self.direction == DIR_RIGHT) then
    self:moveRight()
  elseif (self.direction == DIR_LEFT) then
    self:moveLeft()
  elseif (self.direction == DIR_UP) then
    self:moveUp()
  elseif (self.direction == DIR_DOWN) then
    self:moveDown()
  end
end

return Cursor;