Grid = {
  cell = {},
  width = 0,
  height = 0
}
Grid.__index = Grid

function Grid.new(width, height)
  local grid = {}
  setmetatable(grid, Grid)
  grid.width = width
  grid.height = height
  Grid.fill(grid, width, height)
  return grid
end

function Grid.fill(grid)
  for i = 0, grid.width - 1 do
    grid.cell[i] = {}
    for j = 0, grid.height - 1 do
      grid.cell[i][j] = ""
    end
  end
end

function Grid:set(x, y, value)
  self.cell[x][y] = value
end

function Grid:get(x, y)
  return self.cell[x][y]
end

return Grid;