local Editor = require 'editor'
local Befunge = require 'befunge'
local Task = require 'task'

-- Constants
local BEFUNGE_WIDTH = 10
local BEFUNGE_HEIGHT = 10
local FONT_SIZE = 14

-- Local variables
local editor = nil
local font = nil
local task = nil

function love.load()
  -- Window settings
  love.window.setMode(800, 600, { vsync = true, msaa = 0, highdpi = true })
  
  -- Font settings
  font = love.graphics.newFont('fonts/FSEX300.ttf', 24)
  love.graphics.setFont(font)

  -- Task
  task = Task.new()
  task:load('task_1')

  -- Befunge interpreter
  local bfi = Befunge.new(BEFUNGE_WIDTH, BEFUNGE_HEIGHT, task)

  -- Editor
  editor = Editor.new(bfi)
end

function love.update(dt)
  
end

function love.textinput(char)
  editor:handleCharKeys(char)
end

function love.keypressed(key)
  editor:handleControlKeys(key)
end

function love.draw()
  scale = love.window.getPixelScale()
  love.graphics.scale(scale, scale)
  -- love.graphics.print(tostring(task.input.position), 300, 0)
  task.input:draw(300, 30)
  task.output:draw(350, 30)
  editor:draw()
end