Stream = {
  values = {},
  position = 0
}
Stream.__index = Stream

function Stream.new(values)
  local stream = {}
  setmetatable(stream, Stream)
  stream.values = values
  return stream
end

function Stream:reset()
  self.position = 0
end

function Stream:get()
  if (self.position < #self.values) then
    local temp = self.values[self.position]
    self.position = self.position + 1
    return temp
  end
  return 0
end

function Stream:draw(x, y)
  local offset = 24
  -- Cursor
  local _y = y + self.position * offset
  love.graphics.setColor({255, 255, 255,  64})
  love.graphics.rectangle("fill", x, _y, 30, offset - 1)
  love.graphics.setColor({255, 255, 255, 255})
  -- Values
  for index, value in pairs(self.values) do
    love.graphics.print(value, x, y + index * offset)
  end
end

return Stream;