local Stream = require "stream"

Task = {
  name = "",
  description = {},
  input = nil,
  output = nil
}
Task.__index = Task

function Task.new()
  local task = {}
  setmetatable(task, Task)
  return task
end

function Task:load(taskName)
  local task = require("tasks/" .. taskName)
  self.name = task.getName()
  self.description = task.getDescription()
  local input, output = task.getStreams()
  self.input = Stream.new(input)
  self.output = Stream.new(output)
end

function Task:reset()
  self.input:reset()
  self.output:reset()
end

return Task;